<?php
/* Booked Appointments support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if ( ! function_exists( 'hygia_booked_theme_setup9' ) ) {
	add_action( 'after_setup_theme', 'hygia_booked_theme_setup9', 9 );
	function hygia_booked_theme_setup9() {
		if ( hygia_exists_booked() ) {
			add_action( 'wp_enqueue_scripts', 'hygia_booked_frontend_scripts', 1100 );
			add_action( 'trx_addons_action_load_scripts_front_booked', 'hygia_booked_frontend_scripts', 10, 1 );
			add_action( 'wp_enqueue_scripts', 'hygia_booked_frontend_scripts_responsive', 2000 );
			add_action( 'trx_addons_action_load_scripts_front_booked', 'hygia_booked_frontend_scripts_responsive', 10, 1 );
			add_filter( 'hygia_filter_merge_styles', 'hygia_booked_merge_styles' );
			add_filter( 'hygia_filter_merge_styles_responsive', 'hygia_booked_merge_styles_responsive' );
		}
		if ( is_admin() ) {
			add_filter( 'hygia_filter_tgmpa_required_plugins', 'hygia_booked_tgmpa_required_plugins' );
			add_filter( 'hygia_filter_theme_plugins', 'hygia_booked_theme_plugins' );
		}
	}
}


// Filter to add in the required plugins list
if ( ! function_exists( 'hygia_booked_tgmpa_required_plugins' ) ) {
	//Handler of the add_filter('hygia_filter_tgmpa_required_plugins',	'hygia_booked_tgmpa_required_plugins');
	function hygia_booked_tgmpa_required_plugins( $list = array() ) {
		if ( hygia_storage_isset( 'required_plugins', 'booked' ) && hygia_storage_get_array( 'required_plugins', 'booked', 'install' ) !== false && hygia_is_theme_activated() ) {
			$path = hygia_get_plugin_source_path( 'plugins/booked/booked.zip' );
			if ( ! empty( $path ) || hygia_get_theme_setting( 'tgmpa_upload' ) ) {
				$list[] = array(
					'name'     => hygia_storage_get_array( 'required_plugins', 'booked', 'title' ),
					'slug'     => 'booked',
					'source'   => ! empty( $path ) ? $path : 'upload://booked.zip',
					'version'  => '2.4.3.1',
					'required' => false,
				);
			}
		}
		return $list;
	}
}


// Filter theme-supported plugins list
if ( ! function_exists( 'hygia_booked_theme_plugins' ) ) {
	//Handler of the add_filter( 'hygia_filter_theme_plugins', 'hygia_booked_theme_plugins' );
	function hygia_booked_theme_plugins( $list = array() ) {
		return hygia_add_group_and_logo_to_slave( $list, 'booked', 'booked-' );
	}
}


// Check if plugin installed and activated
if ( ! function_exists( 'hygia_exists_booked' ) ) {
	function hygia_exists_booked() {
		return class_exists( 'booked_plugin' );
	}
}


// Return a relative path to the plugin styles depend the version
if ( ! function_exists( 'hygia_booked_get_styles_dir' ) ) {
	function hygia_booked_get_styles_dir( $file ) {
		$base_dir = 'plugins/booked/';
		return $base_dir
				. ( defined( 'BOOKED_VERSION' ) && version_compare( BOOKED_VERSION, '2.4', '<' ) && hygia_get_folder_dir( $base_dir . 'old' )
					? 'old/'
					: ''
					)
				. $file;
	}
}


// Enqueue styles for frontend
if ( ! function_exists( 'hygia_booked_frontend_scripts' ) ) {
	//Handler of the add_action( 'wp_enqueue_scripts', 'hygia_booked_frontend_scripts', 1100 );
	//Handler of the add_action( 'trx_addons_action_load_scripts_front_booked', 'hygia_booked_frontend_scripts', 10, 1 );
	function hygia_booked_frontend_scripts( $force = false ) {
		hygia_enqueue_optimized( 'booked', $force, array(
			'css' => array(
				'hygia-booked' => array( 'src' => hygia_booked_get_styles_dir( 'booked.css' ) ),
			)
		) );
	}
}


// Enqueue responsive styles for frontend
if ( ! function_exists( 'hygia_booked_frontend_scripts_responsive' ) ) {
	//Handler of the add_action( 'wp_enqueue_scripts', 'hygia_booked_frontend_scripts_responsive', 2000 );
	//Handler of the add_action( 'trx_addons_action_load_scripts_front_booked', 'hygia_booked_frontend_scripts_responsive', 10, 1 );
	function hygia_booked_frontend_scripts_responsive( $force = false ) {
		hygia_enqueue_optimized_responsive( 'booked', $force, array(
			'css' => array(
				'hygia-booked-responsive' => array( 'src' => hygia_booked_get_styles_dir( 'booked-responsive.css' ), 'media' => 'all' ),
			)
		) );
	}
}


// Merge custom styles
if ( ! function_exists( 'hygia_booked_merge_styles' ) ) {
	//Handler of the add_filter('hygia_filter_merge_styles', 'hygia_booked_merge_styles');
	function hygia_booked_merge_styles( $list ) {
		$list[ hygia_booked_get_styles_dir( 'booked.css' ) ] = false;
		return $list;
	}
}


// Merge responsive styles
if ( ! function_exists( 'hygia_booked_merge_styles_responsive' ) ) {
	//Handler of the add_filter('hygia_filter_merge_styles_responsive', 'hygia_booked_merge_styles_responsive');
	function hygia_booked_merge_styles_responsive( $list ) {
		$list[ hygia_booked_get_styles_dir( 'booked-responsive.css' ) ] = false;
		return $list;
	}
}


// Add plugin-specific colors and fonts to the custom CSS
if ( hygia_exists_booked() ) {
	$hygia_fdir = hygia_get_file_dir( hygia_booked_get_styles_dir( 'booked-style.php' ) );
	if ( ! empty( $hygia_fdir ) ) {
		require_once $hygia_fdir;
	}
}
